diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index aaf5ebfb1..72aaac246 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block.entity;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRotatable;
+import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
@@ -206,8 +206,8 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
-        return super.getCarriedEntry(world, holder, currentBlock, BlockRotatable.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, BlockLogicRotatable.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
     }
 
     private ItemStack dispenserContents[];
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
index cfc9e0f57..2c6399051 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFlowerStackable;
+import net.minecraft.core.block.BlockLogicFlowerStackable;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.item.ItemStack;
@@ -34,10 +34,10 @@ public class TileEntityFlowerJar extends TileEntity {
     @Override
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
-        if (flowerInPot > 0 && Block.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
+        if (flowerInPot > 0 && Blocks.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
             if (!world.isClientSide) {
-                if (Blocks.getBlock(flowerInPot) instanceof BlockFlowerStackable) {
-                    world.dropItem(x, y, z, new ItemStack(flowerInPot, BlockFlowerStackable.getStackCount(flowerData) + 1, 0));
+                if (Block.hasLogicClass(Blocks.getBlock(flowerInPot), BlockLogicFlowerStackable.class)) {
+                    world.dropItem(x, y, z, new ItemStack(flowerInPot, BlockLogicFlowerStackable.getStackCount(flowerData) + 1, 0));
                 } else {
                     world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, flowerData));
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index fbb60f1e0..1976b97d5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -2,10 +2,10 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFurnace;
+import net.minecraft.core.block.BlockLogicFurnace;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
@@ -178,9 +178,9 @@ public class TileEntityFurnace extends TileEntity
         }
         if(worldObj == null || !worldObj.isClientSide)
         {
-        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id) {
+        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id()) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
-            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.COBBLE_NETHERRACK.id) {
+            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.COBBLE_NETHERRACK.id()) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
             			updateFurnace(true);
@@ -306,9 +306,9 @@ public class TileEntityFurnace extends TileEntity
 
     protected void updateFurnace(boolean forceLit){
         if (worldObj != null) {
-            BlockFurnace.updateFurnaceBlockState( forceLit | (currentBurnTime > 0), worldObj, x, y, z);
+            BlockLogicFurnace.updateFurnaceBlockState( forceLit | (currentBurnTime > 0), worldObj, x, y, z);
         } else if (carriedBlock != null) {
-            carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_STONE_ACTIVE.id : Blocks.FURNACE_STONE_IDLE.id;
+            carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_STONE_ACTIVE.id() : Blocks.FURNACE_STONE_IDLE.id();
         }
     }
 
@@ -332,7 +332,7 @@ public class TileEntityFurnace extends TileEntity
     @Override
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
-        if(!BlockFurnace.keepFurnaceInventory)
+        if(!BlockLogicFurnace.keepFurnaceInventory)
         {
             label0:
             for(int l = 0; l < this.getContainerSize(); l++)
@@ -399,7 +399,7 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
         return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
similarity index 94%
rename from game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 2a7200eee..6bf07adcb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.BlockFurnaceBlast;
+import net.minecraft.core.block.BlockLogicFurnaceBlast;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.crafting.LookupFuelFurnaceBlast;
 import net.minecraft.core.data.registry.Registries;
@@ -12,12 +12,12 @@ import net.minecraft.core.player.inventory.container.Container;
 
 import java.util.List;
 
-public class TileEntityFurnaceBlastFurnace extends TileEntityFurnace
+public class TileEntityFurnaceBlast extends TileEntityFurnace
         implements Container
 {
 
 
-    public TileEntityFurnaceBlastFurnace()
+    public TileEntityFurnaceBlast()
     {
         super();
         maxCookTime = 100;
@@ -84,9 +84,9 @@ public class TileEntityFurnaceBlastFurnace extends TileEntityFurnace
         }
         if(worldObj == null || !worldObj.isClientSide)
         {
-        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_BLAST_IDLE.id) {
+        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_BLAST_IDLE.id()) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
-            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.COBBLE_NETHERRACK.id) {
+            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.COBBLE_NETHERRACK.id()) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
             			updateFurnace(true);
@@ -138,9 +138,9 @@ public class TileEntityFurnaceBlastFurnace extends TileEntityFurnace
     @Override
     protected void updateFurnace(boolean forceLit){
         if (worldObj != null) {
-            BlockFurnaceBlast.updateFurnaceBlockState(forceLit | (currentBurnTime > 0), worldObj, x, y, z);
+            BlockLogicFurnaceBlast.updateFurnaceBlockState(forceLit | (currentBurnTime > 0), worldObj, x, y, z);
         } else if (carriedBlock != null) {
-            carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_BLAST_ACTIVE.id : Blocks.FURNACE_BLAST_IDLE.id;
+            carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_BLAST_ACTIVE.id() : Blocks.FURNACE_BLAST_IDLE.id();
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 4f3e6649a..09c956409 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -55,7 +55,7 @@ public class TileEntityMobSpawner extends TileEntity
     @Override
 	public void tick()
     {
-        if (worldObj.getBlockId(x, y, z) != Blocks.MOBSPAWNER.id) return; // dumb fix for mp particle bug, need proper way to inform client to remove tileEntity
+        if (worldObj.getBlockId(x, y, z) != Blocks.MOBSPAWNER.id()) return; // dumb fix for mp particle bug, need proper way to inform client to remove tileEntity
         yaw2 = yaw;
         if(!anyPlayerInRange())
         {
@@ -148,7 +148,7 @@ public class TileEntityMobSpawner extends TileEntity
     		for(int j = -r; j <= r; j++) {
     			for(int k = -r; k <= r; k++) {
     				int id = worldObj.getBlockId(x + i, y + j, z + k);
-    				if(id == Blocks.MOBSPAWNER.id) {
+    				if(id == Blocks.MOBSPAWNER.id()) {
     					count++;
     				}
     			}
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
index 7e00eb25b..342f815df 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockNote;
+import net.minecraft.core.block.BlockLogicNote;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -19,7 +19,7 @@ public class TileEntityNoteblock extends TileEntity
     @Override
     public void tick() {
         if (worldObj.getBlock(x, y, z) == Blocks.NOTEBLOCK) { // Set note block pitch
-            worldObj.setBlockMetadata(x, y, z, BlockNote.setNote(0, note));
+            worldObj.setBlockMetadata(x, y, z, BlockLogicNote.setNote(0, note));
         }
         invalidate(); // Delete self
     }
@@ -33,7 +33,7 @@ public class TileEntityNoteblock extends TileEntity
     @Override
 	public void readFromNBT(CompoundTag tag) {
         super.readFromNBT(tag);
-        note = MathHelper.clamp(tag.getByte("note"), (byte) 0, BlockNote.MAX_NOTE);
+        note = MathHelper.clamp(tag.getByte("note"), (byte) 0, BlockLogicNote.MAX_NOTE);
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
index 2485e6d0f..e8f32984e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.entity;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.IVehicle;
@@ -13,11 +13,11 @@ public class TileEntitySeat
     implements IVehicle {
     private Entity passenger;
 
-    public Block seat;
+    public Block<?> seat;
     public TileEntitySeat() {
         this(null);
     }
-    public TileEntitySeat(Block seat) {
+    public TileEntitySeat(Block<?> seat) {
         passenger = null;
         this.seat = seat;
     }
@@ -142,7 +142,7 @@ public class TileEntitySeat
     {
         super.writeToNBT(compoundTag);
         if (seat != null && seat != Blocks.SEAT) {
-            compoundTag.putInt("Block", seat.id);
+            compoundTag.putInt("Block", seat.id());
         }
     }
 
@@ -150,6 +150,6 @@ public class TileEntitySeat
     public void readFromNBT(CompoundTag compoundTag)
     {
         super.readFromNBT(compoundTag);
-        seat = Blocks.getBlock(compoundTag.getIntegerOrDefault("Block", Blocks.SEAT.id));
+        seat = Blocks.getBlock(compoundTag.getIntegerOrDefault("Block", Blocks.SEAT.id()));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index 39a23e871..a699744a0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -3,9 +3,8 @@ package net.minecraft.core.block.entity;
 import java.util.List;
 
 import net.minecraft.core.achievement.Achievements;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockMotionSensor;
+import net.minecraft.core.block.BlockLogicMotionSensor;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -24,7 +23,7 @@ public class TileEntitySensor extends TileEntity {
 		
 		int range = 4;
 		int blockInFront = world.getBlockId(MathHelper.round(x + facing.getOffsetX()), MathHelper.round(y + facing.getOffsetY()), MathHelper.round(z + facing.getOffsetZ()));
-		if(Block.hasTag(blockInFront, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
+		if(Blocks.hasTag(blockInFront, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
 			range = 8;
 		}
 		
@@ -33,7 +32,7 @@ public class TileEntitySensor extends TileEntity {
 			int y1 = MathHelper.round(y + facing.getOffsetY() * i);
 			int z1 = MathHelper.round(z + facing.getOffsetZ() * i);
 			int id = world.getBlockId(x1, y1, z1);
-			if(Blocks.solid[id] && !Block.hasTag(id, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
+			if(Blocks.solid[id] && !Blocks.hasTag(id, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
 				return i - 1;
 			}
 		}
@@ -71,7 +70,7 @@ public class TileEntitySensor extends TileEntity {
 		int meta = worldObj.getBlockMetadata(x, y, z);
 		
 		boolean shouldBeActive = false;
-		Direction facing = BlockMotionSensor.getFacingDirection(meta);
+		Direction facing = BlockLogicMotionSensor.getFacingDirection(meta);
 		int effectiveRange = getSightRange(worldObj, x, y, z, facing);
 		if(effectiveRange > 0) {
 			AABB detectionBox = getDetectionBox(x, y, z, facing, effectiveRange);
@@ -86,11 +85,11 @@ public class TileEntitySensor extends TileEntity {
 			}
 		}
 		
-		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id) {
+		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
 			worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "tile.sensor_block.sense", 1f, worldObj.rand.nextFloat());
 			updateSensorBlockState(true, worldObj);
 		}
-		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id) {
+		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
 			updateSensorBlockState(false, worldObj);
 		}
 	}
@@ -106,7 +105,7 @@ public class TileEntitySensor extends TileEntity {
 		int meta = carriedBlock.metadata;
 
 		boolean shouldBeActive = false;
-		Direction facing = BlockMotionSensor.getFacingDirection(meta);
+		Direction facing = BlockLogicMotionSensor.getFacingDirection(meta);
 		int effectiveRange = getSightRange(world, holder.x, holder.y, holder.z, facing);
 		if(effectiveRange > 0) {
 			AABB detectionBox = getDetectionBox(holder.x, holder.y, holder.z, facing, effectiveRange);
@@ -122,11 +121,11 @@ public class TileEntitySensor extends TileEntity {
 			}
 		}
 
-		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id) {
+		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id()) {
 			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "tile.sensor_block.sense", 1f, world.rand.nextFloat());
 			updateSensorBlockState(true, world);
 		}
-		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id) {
+		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id()) {
 			updateSensorBlockState(false, world);
 		}
 	}
@@ -134,17 +133,17 @@ public class TileEntitySensor extends TileEntity {
 	public void updateSensorBlockState(boolean active, World world) {
 		if (carriedBlock != null) {
             if(active) {
-				carriedBlock.blockId = Blocks.MOTION_SENSOR_ACTIVE.id;
+				carriedBlock.blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
 			}else {
-				carriedBlock.blockId = Blocks.MOTION_SENSOR_IDLE.id;
+				carriedBlock.blockId = Blocks.MOTION_SENSOR_IDLE.id();
 			}
 		} else {
 			int meta = world.getBlockMetadata(x, y, z);
 			int blockId;
 			if(active) {
-				blockId = Blocks.MOTION_SENSOR_ACTIVE.id;
+				blockId = Blocks.MOTION_SENSOR_ACTIVE.id();
 			}else {
-				blockId = Blocks.MOTION_SENSOR_IDLE.id;
+				blockId = Blocks.MOTION_SENSOR_IDLE.id();
 			}
 			world.setBlock(x, y, z, blockId);
 			world.setBlockMetadata(x, y, z, meta);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index aee215574..0df117025 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -4,11 +4,11 @@ package net.minecraft.core.block.entity;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockChest;
-import net.minecraft.core.block.BlockTrommel;
+import net.minecraft.core.block.BlockLogicChest;
+import net.minecraft.core.block.BlockLogicTrommel;
 import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
@@ -180,15 +180,15 @@ public class TileEntityTrommel extends TileEntity
         }
         if(worldObj == null || !worldObj.isClientSide)
         {
-        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id) {
+        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id()) {
             	if(currentItemBurnTime == 0 && itemStacks[0] == null) {
-            		if(itemStacks[4] != null && itemStacks[4].itemID == Blocks.COBBLE_NETHERRACK.id) {
+            		if(itemStacks[4] != null && itemStacks[4].itemID == Blocks.COBBLE_NETHERRACK.id()) {
             			itemStacks[4].stackSize--;
             			if(itemStacks[4].stackSize <= 0) itemStacks[4] = null;
             			if (worldObj != null) {
-                            BlockTrommel.updateTrommelBlockState(true, worldObj, x, y, z);
+                            BlockLogicTrommel.updateTrommelBlockState(true, worldObj, x, y, z);
                         } else if (carriedBlock != null) {
-                            carriedBlock.blockId = Blocks.TROMMEL_ACTIVE.id;
+                            carriedBlock.blockId = Blocks.TROMMEL_ACTIVE.id();
                         }
                         flag1 = true;
                     }
@@ -234,9 +234,9 @@ public class TileEntityTrommel extends TileEntity
             {
                 flag1 = true;
                 if (worldObj != null) {
-                    BlockTrommel.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
+                    BlockLogicTrommel.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
                 } else if (carriedBlock != null) {
-                    carriedBlock.blockId = burnTime > 0 ? Blocks.TROMMEL_ACTIVE.id : Blocks.TROMMEL_IDLE.id;
+                    carriedBlock.blockId = burnTime > 0 ? Blocks.TROMMEL_ACTIVE.id() : Blocks.TROMMEL_IDLE.id();
                 }
             }
         }
@@ -291,9 +291,9 @@ public class TileEntityTrommel extends TileEntity
         	int adjacentId = worldObj != null ? worldObj.getBlockId(x + xOffset, y, z + zOffset) : 0;
         	
         	Container chest = null;
-        	if (Blocks.blocksList[adjacentId] instanceof BlockChest) {
+        	if (Block.hasLogicClass(Blocks.blocksList[adjacentId], BlockLogicChest.class)) {
                 assert worldObj != null;
-                chest = BlockChest.getInventory(worldObj, x + xOffset, y, z + zOffset);
+                chest = BlockLogicChest.getInventory(worldObj, x + xOffset, y, z + zOffset);
         	}
         	
         	if (chest != null)
@@ -405,7 +405,7 @@ public class TileEntityTrommel extends TileEntity
     @Override
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
-        if (!BlockTrommel.keepTrommelInventory)
+        if (!BlockLogicTrommel.keepTrommelInventory)
         {
             if(world.getBlockEntity(x, y, z) != null)
             {
@@ -535,7 +535,7 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
         return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java b/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
index e8ab9faef..c1957bf50 100644
--- a/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
@@ -90,14 +90,14 @@ public class MaterialColor {
         materialColors[id] = this;
     }
 
-    private static int makeBlockIndex(Block block, int meta){
-        return block.id << 8 | meta;
+    private static int makeBlockIndex(Block<?> block, int meta){
+        return block.id() << 8 | meta;
     }
-    public static void registerManualBlockColor(Block block, int meta, MaterialColor color){
+    public static void registerManualBlockColor(Block<?> block, int meta, MaterialColor color){
         int blockIndex = makeBlockIndex(block, meta);
         blockIdColorIndexMap.put(blockIndex, color.id);
     }
-    public static int getColorIndexFromBlock(Block block, int meta){
+    public static int getColorIndexFromBlock(Block<?> block, int meta){
         int blockIndex = makeBlockIndex(block, meta);
         if (blockIdColorIndexMap.containsKey(blockIndex)){
             return blockIdColorIndexMap.get(blockIndex);
diff --git a/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
index 05af9554c..ac6113479 100644
--- a/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block.motion;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -23,8 +23,8 @@ public class CarriedBlock implements ICarriable {
     // Ignore warnings, nbt read process *should* guarantee these to be non-null
     public @NotNull Entity holder;
     public @NotNull World world;
-    public CarriedBlock(@NotNull Entity holder, @NotNull Block block, int metadata, @Nullable TileEntity entity) {
-        this(holder, block.id, metadata, entity);
+    public CarriedBlock(@NotNull Entity holder, @NotNull Block<?> block, int metadata, @Nullable TileEntity entity) {
+        this(holder, block.id(), metadata, entity);
     }
 
     public CarriedBlock(@NotNull Entity holder, int blockId, int metadata, @Nullable TileEntity entity) {
@@ -42,7 +42,7 @@ public class CarriedBlock implements ICarriable {
         assert world != null : "Carried block world ref must not be null!";
     }
 
-    public Block block() {
+    public Block<?> block() {
         return Blocks.getBlock(blockId);
     }
 
@@ -62,11 +62,11 @@ public class CarriedBlock implements ICarriable {
             int y = blockY + side.getOffsetY();
             int z = blockZ + side.getOffsetZ();
 
-            Block currentBlock = world.getBlock(x, y, z);
+            Block<?> currentBlock = world.getBlock(x, y, z);
             if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
             world.setBlockAndMetadataWithNotify(x, y, z, blockId, metadata);
 
-            Block b = world.getBlock(x, y, z);
+            Block<?> b = world.getBlock(x, y, z);
             if (b != null && holder instanceof Mob) {
                 b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
             }
